$fn=20; // Number of fragments

// Brick dimensions
studX = 1; // number of studs on the X axis
studY = 6; // number of studs on the Y axis
studZ = 3; // height of the brick (1 for plates, 3 for bricks)

// Stud variables
studHeight  = 1.60;
studRadius  = 2.40;
studSpacing = 8.00;
studOffset  = 4.00;

// Brick variables
brickLength        = studX * studSpacing;
brickWidth         = studY * studSpacing;
brickHeight        = studZ * 3.20;
brickWallThickness = 1.40;
brickTopThickness  = 1.00;

// Socket variables
socketRadius = 3.25;
socketOffset = 7.90;

// Brick
difference() {
    // Outer brick
    cube([brickLength,brickWidth,brickHeight]);

    // Inner brick (hollow)
    translate([brickWallThickness,brickWallThickness])
    cube([
        brickLength - 2 * brickWallThickness,
        brickWidth - 2 * brickWallThickness,
        brickHeight - brickTopThickness
    ]);
}

// Studs
translate([studOffset,studOffset])
for(y = [0:studY - 1]) {
    for(x = [0:studX - 1]) {
        // Stud
        translate([x * studSpacing, y * studSpacing, brickHeight])
        cylinder(h = studHeight, r = studRadius);
    }
}

// Sockets
if (studX > 1 && studY > 1) {
    translate([socketOffset,socketOffset])
    for(y = [0:studY - 2]) {
        for(x = [0:studX - 2]) {
            translate([x * studSpacing,y * studSpacing])
            difference() {
                // Outer socket
                cylinder(
                    h = brickHeight - brickTopThickness,
                    r = socketRadius
                );
    
                // Inner socket (hollow)
                cylinder(
                    h = brickHeight - brickTopThickness,
                    r = studRadius
                );
            }
        }
    }
}